    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * --------------
    028 * SortOrder.java
    029 * --------------
    030 * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * $Id: SortOrder.java,v 1.6 2005/10/18 13:24:19 mungady Exp $
    036 *
    037 * Changes:
    038 * --------
    039 * 05-Mar-2003 : Version 1 (DG);
    040 * 13-Mar-2003 : Implemented Serializable (DG);
    041 * 27-Aug-2003 : Moved from JFreeChart --> JCommon (DG);
    042 * 29-Jul-2004 : Fixed error in readResolve() method (DG);
    043 *
    044 */
    045
    046package org.jfree.util;
    047
    048import java.io.ObjectStreamException;
    049import java.io.Serializable;
    050
    051/**
    052 * Defines tokens used to indicate sorting order (ascending or descending).
    053 *
    054 * @author David Gilbert
    055 */
    056public final class SortOrder implements Serializable {
    057
    058    /** For serialization. */
    059    private static final long serialVersionUID = -2124469847758108312L;
    060
    061    /** Ascending order. */
    062    public static final SortOrder ASCENDING
    063        = new SortOrder("SortOrder.ASCENDING");
    064
    065    /** Descending order. */
    066    public static final SortOrder DESCENDING
    067        = new SortOrder("SortOrder.DESCENDING");
    068
    069    /** The name. */
    070    private String name;
    071
    072    /**
    073     * Private constructor.
    074     *
    075     * @param name  the name.
    076     */
    077    private SortOrder(final String name) {
    078        this.name = name;
    079    }
    080
    081    /**
    082     * Returns a string representing the object.
    083     *
    084     * @return The string.
    085     */
    086    public String toString() {
    087        return this.name;
    088    }
    089
    090    /**
    091     * Returns <code>true</code> if this object is equal to the specified
    092     * object, and <code>false</code> otherwise.
    093     *
    094     * @param obj  the other object.
    095     *
    096     * @return A boolean.
    097     */
    098    public boolean equals(final Object obj) {
    099
    100        if (this == obj) {
    101            return true;
    102        }
    103        if (!(obj instanceof SortOrder)) {
    104            return false;
    105        }
    106
    107        final SortOrder that = (SortOrder) obj;
    108        if (!this.name.equals(that.toString())) {
    109            return false;
    110        }
    111
    112        return true;
    113    }
    114
    115    /**
    116     * Returns a hash code value for the object.
    117     *
    118     * @return The hashcode
    119     */
    120    public int hashCode() {
    121        return this.name.hashCode();
    122    }
    123
    124    /**
    125     * Ensures that serialization returns the unique instances.
    126     *
    127     * @return The object.
    128     *
    129     * @throws ObjectStreamException if there is a problem.
    130     */
    131    private Object readResolve() throws ObjectStreamException {
    132        if (this.equals(SortOrder.ASCENDING)) {
    133            return SortOrder.ASCENDING;
    134        }
    135        else if (this.equals(SortOrder.DESCENDING)) {
    136            return SortOrder.DESCENDING;
    137        }
    138        return null;
    139    }
    140}